/* -----------------------------------------
   RQRDDFIREv.0.9.0 by Roque (Sep.2007)
   -----------------------------------------

                         R E F E R E N C E   P R O G R A M
                         ==================================

PORTUGUESE SPEAKERS read this:
 
         HIGHLY NEEDED! = EXTREMAMENTE NECESSRIO
         (need TestNNN) = ESTA FUNO PRECISA DAS AES EXECUTAS EM TestNNN

*/       
#include "rqfbconn.fh" // HIGHLY NEEDED!
#include "error.fh"

request rqRDDFireNew   // HIGHLY NEEDED!

#define USER      "SYSDBA"    // Firebird Superuser    ! CHECK !
#define USER_PWD  "masterkey" // default is masterkey  ! CHECK !

Function Main()
  Set Date British

  // THE TESTING FUNCTIONS BELOW WERE DESIGN TO BE EXECUTED INDIVIDUALLY
  // BUT SOME OF THEM MAY REQUIRE ACTIONS TAKEN PREVIOUSLY
  // -------------------------------------------------------------------

  Test001()  // Tables of a Database
  Test002()  // Import
  Test003()  // Browsing              (need Test002)
  Test004()  // Browsing Faster       (need Test002)
  Test004a() // Filter                (need Test002)
  Test005()  // Table Structure       (need Test002)
  Test006()  // Indexes               (need Test002)
  Test007()  // Replace               (need Test002/006)
  Test008()  // Append                (need Test002/006)
  Test009()  // Resultset             (need Test002)
  Test009a() // Promoted Resultset    (need Test002)
  //Test010()  // DBEval                (need Test002) ??? not implemented
  Test011()  // Export                (need Test002)
  Test012()  // Hybrid use of DBFIDX and RQRDDFIRE (need Test002/011)
  Return

// ------------------------------------------------------------------------ 001
Function Test001() // Tables of a Database

  // Goal: Demonstrates a simple database connection using rqFBConn. A Database
  // ====  Connection can be established once inside an application, or several
  //       times during its execution. The database may be located on the same
  //       machine or be accessed remotely, like: server2:/home/data/sample.fdb
  Local oConn := rqFBConn{ "sample.fdb", USER, USER_PWD, "" } AS rqFBConn
  Local aAux
  Local iCt

  Clear Screen
  Alert( "TEST001: Tables of a Database" )
  IF oConn:isConnected()

    aAux := oConn:getTablesName()
    For iCt := 1 To Len( aAux )
      ? "Table: " + aAux[iCt]
    Next

    oConn:disconnect()
  Endif
  ? "Press. any key..." ; Inkey( 0 )
  Return

// ------------------------------------------------------------------------ 002
Function Test002() // Import Operation

  // Goal: Demonstrates an import operation using rqFBConn.
  // ====
  Local oConn := rqFBConn{ "sample.fdb", USER, USER_PWD, "" } AS rqFBConn

  Clear Screen
  Alert( "TEST002: Import Operation" )
  IF oConn:isConnected()
    oConn:setLogLevel( 8 ) // optional: observe /var/log/rqrddfire.log file

    // IMPORTANT: Sometimes DROP operations return an error when isql sessions
    //            leave unfinished transactions around.
    IIF( oConn:isTable("mydbf"), oConn:dropTable("mydbf") ) // drop if exists

    // IMPORTANT: "/tmp" right below MUST be in firebird.conf as an allowed 
    //            directory to work with external tables. 
    //            Ex: ExternalFileAccess = Restrict /tmp
    oConn:setFullpathDATFile( "/tmp/temp.dat" )

    oConn:bringDBF( "./mydbf.dbf" )

    Qout( "Tables: " ) ; AEval( oConn:getTablesName(),{|x| QQout(x + " :: ")} )
    oConn:disconnect()
  Endif
  ? "Press. any key..." ; Inkey( 0 )
  Return

// ------------------------------------------------------------------------ 003
Function Test003() // Browsing

  // Goal: Makes really use of the RDD by browsing the table imported at 
  // ====  Test002.
  Local oConn := rqFBConn{ "sample.fdb", USER, USER_PWD, "" } AS rqFBConn

  Clear Screen
  Alert( "TEST003: Browsing" )
  IF oConn:isConnected()
  
    // m->oConn1 is a global variable declared inside rqFBConn. RQRDDFIRE uses 
    // the connection specified by it
    m->oConn1 := oConn  // HIGHLY NEEDED! 

    Delete File mydbf.dbf // optional: to avoid doubts ;)

    Use mydbf Alias tb Via rqRDDFire Shared New
    //                     ^^^^^^^^^               HIGHLY NEEDED! or
    //                                             use DBSETDRIVER("RQRDDFIRE")
    Browse()
    Close tb // good practice, but RQRDDFIRE will try close this alias when 
             // the connection is finished. When not done, it might jeopardize 
             // later DROP operations (see Test002)

    oConn:disconnect()
  Endif
  Return

// ------------------------------------------------------------------------ 004
Function Test004() // Browsing Faster

  // Goal: Makes really use of the RDD by browsing the table imported at 
  // ====  Test002 and shows how to optimize table access to get better 
  //       perfomance.
  Local oConn := rqFBConn{ "sample.fdb", USER, USER_PWD, "" } AS rqFBConn

  Clear Screen
  Alert( "TEST004: Browsing Faster" )
  IF oConn:isConnected()
  
    m->oConn1 := oConn  // HIGHLY NEEDED! see Test003

    Use mydbf Alias tb Via rqRDDFire Shared New 

    // optional: set cache operation mode
    Local oDBSvr := DBObject( "tb" ) AS rqRDDFire // see FSMAN::FUN::DBOBJECT
    oDBSvr:setSkipCacheSize( 100 )
    oDBSvr:setSkipMode( 2 ) // [0] Strict [1] Default [2] Cached
                            //  Slowest    Normal      Fastest

    Browse()
    Close tb

    oConn:disconnect()
  Endif
  Return

// ----------------------------------------------------------------------- 004a
Function Test004a() // Filter

  // Goal: Introduces FS Set Filter command.
  // ====  Be advised: Set Filter is for compatibily only. Its actual  
  //       perfomance is VERY poor. Use Index or ResultSet instead.
  Local oConn := rqFBConn{ "sample.fdb", USER, USER_PWD, "" } AS rqFBConn

  // optional: Setting SkipMode and Cache Size globally for all tables
  oConn:setGlbSkipCacheSize(100)
  oConn:setGlbSkipMode(2)

  Clear Screen
  Alert( "TEST004a: Filtering" )
  IF oConn:isConnected()
    m->oConn1 := oConn  // HIGHLY NEEDED! see Test003

    Use mydbf Alias tb Via rqRDDFire Shared New 
    Set Filter To VE_VLLIQU > 4000.00
   
    Go Top
    Browse()
    Close tb

    oConn:disconnect()
  Endif
  Return

// ------------------------------------------------------------------------ 005
Function Test005() // Table Structure

  // Goal: Demonstrates how RQRDDFIRE translates FB table structure to DBFIDX
  // ====  structure.
  Local oConn := rqFBConn{ "sample.fdb", USER, USER_PWD, "" } AS rqFBConn

  Clear Screen
  Alert( "TEST005: Table Structure" )
  IF oConn:isConnected()
    m->oConn1 := oConn  // HIGHLY NEEDED! see Test003

    Use mydbf Alias tb Via rqRDDFire Shared New
    IF Used()
      Local aStru := DbStruct()
      For iCt := 1 To Len(aStru)
        ? "Field: " + aStru[iCt,1] + " TYPE: " + aStru[iCt,2] + " SIZE: " + ;
          Str(aStru[iCt,3],3) + " DEC.: " + Str(aStru[iCt,4],3)
      Next
      Close tb
    Endif

    oConn:disconnect()
  Endif
  ? "Press. any key..." ; Inkey( 0 )
  Return

// ------------------------------------------------------------------------ 006
Function Test006() // Indexes

  // Goal: RDD index creation. Please refer to the documentation to learn some
  // ====  limitations of this operation.
  Local oConn := rqFBConn{ "sample.fdb", USER, USER_PWD, "" } AS rqFBConn

  Clear Screen
  Alert( "TEST006: Indexes" )
  IF oConn:isConnected()
    m->oConn1 := oConn  // HIGHLY NEEDED! see Test003

    Use mydbf Alias tb Via rqRDDFire Shared New
    IF Used()

      Index On VE_CODIGO+DTOS(VE_DTVEND) To myidx1
      // or
      DbCreateIndex("myidx2", "DTOS(VE_DTVEND)+STR(VE_VLTOTA,10,2)",, .F.)

      Set Index To myidx1, myidx2
      Set Order To 2

      // see Test004
      Local oDBSvr := DBObject( "tb" ) AS rqRDDFire // see FSMAN::FUN::DBOBJECT
      oDBSvr:setSkipCacheSize( 100 )
      oDBSvr:setSkipMode( 2 ) // [0] Strict [1] Default [2] Cached

      Alert( "Using Index(" + Alltrim(Str(IndexOrd())) + ") Expression: " ;
             + IndexKey() )
      Go Top
      Browse() 
      Close tb
    Endif

    oConn:disconnect()
  Endif
  Return

// ------------------------------------------------------------------------ 007
Function Test007() // Replace

  // Goal: Demonstrates an update operation on FB tables.
  // ====
  Local oConn := rqFBConn{ "sample.fdb", USER, USER_PWD, "" } AS rqFBConn

  Clear Screen
  Alert( "TEST007: Replace/FieldPut" )
  IF oConn:isConnected()
    m->oConn1 := oConn  // HIGHLY NEEDED! see Test003

    Use mydbf Alias tb Via rqRDDFire Shared New
    IF Used()
      Set Index To myidx1
      Set Order To 1

      // I M P O R T A N T :
      // REPLACE [<alias>->]<field1> WITH [<alias>->]<field2> does not work
      // properly. Use FieldPut instead. To replace all REPLACE commands inside
      // your application use 'repl2put' in 'tools' directory. However,
      // REPLACE [<alias>->]<field1> WITH <exp> works nicely.

      tb->VE_CODIGO := "000001"                 // This format is OK
      // or
      Replace tb->VE_CODIGO With "000002"       // OK
      // or
      FieldPut(FieldPos("VE_CODIGO"), "000003") // OK
      FieldPut(FieldPos("VE_VLTOTA"), 2.00)
      tb->(DBCommit())
      
      Go Top
      Browse() 
      Close tb
    Endif

    oConn:disconnect()
  Endif
  Return

// ------------------------------------------------------------------------ 008
Function Test008() // Append

  // Goal: Simple Append operation
  // ====
  Local oConn := rqFBConn{ "sample.fdb", USER, USER_PWD, "" } AS rqFBConn

  Clear Screen
  Alert( "TEST008: Append" )
  IF oConn:isConnected()
    m->oConn1 := oConn  // HIGHLY NEEDED! see Test003

    Use mydbf Alias tb Via rqRDDFire Shared New
    IF Used()

      Append Blank
      tb->VE_CODIGO := "000000"
      tb->VE_STATUS := "E"
      tb->VE_CLIEN  := "00001"
      tb->VE_DTVEND := Date()
      tb->VE_HOVEND := Time()
      tb->VE_VLTOTA := 1.00
      tb->(DBUnlock())

      // see Test004 [optional]
      Local oDBSvr := DBObject( "tb" ) AS rqRDDFire // see FSMAN::FUN::DBOBJECT
      oDBSvr:setSkipCacheSize( 100 )
      oDBSvr:setSkipMode( 2 ) 

      Set Index To myidx1 // Note: Indexes are updated automatically even
                          //       they are unopened. So, corruption is not
                          //       possible!
      Set Order To 1
      Go Top
      Browse() 

      Close tb
    Endif

    oConn:disconnect()
  Endif
  Return

// ------------------------------------------------------------------------ 009
Function Test009() // Resultsets

  // Goal: An example of how RQRDDFIRE can execute pure SQL statements.
  // ====  Remember, the generated resultsets are READONLY!
  Local oConn := rqFBConn{ "sample.fdb", USER, USER_PWD, "" } AS rqFBConn

  Clear Screen
  Alert( "TEST009: Resultset" )
  IF oConn:isConnected()
    m->oConn1 := oConn  // HIGHLY NEEDED! see Test003

    Local rs := rqFBRS{ ;
      "SELECT FIRST 20 VE_DTVEND, VE_CLIEN, VE_VLTOTA " ; 
      + "FROM MYDBF ORDER BY VE_CLIEN" } AS rqFBRS

    IF rs:isActive() // successful?
      rs:beforeFirst()
      While rs:next()
        ? rs:getString("VE_CLIEN"), rs:getString("VE_VLTOTA"), ;
          rs:getValue("VE_DTVEND")
      Enddo
    Endif

    oConn:disconnect()
  Endif
  ? "Press. any key..." ; Inkey( 0 )
  Return

// ----------------------------------------------------------------------- 009a
Function Test009a() // More Resultsets

  // Goal: An example of how RQRDDFIRE can execute pure SQL statements.
  // ====  Remember, the generated resultsets are READONLY!
  //       This times using 'promoteRStoAlias' method... cool!
  Local oConn := rqFBConn{ "sample.fdb", USER, USER_PWD, "" } AS rqFBConn

  Clear Screen
  Alert( "TEST009a: Promoted Resultset" )
  IF oConn:isConnected()
    m->oConn1 := oConn  // HIGHLY NEEDED! see Test003

    Local rs := rqFBRS{ "SELECT * FROM MYDBF ORDER BY VE_CLIEN" } AS rqFBRS

    IF( rs:isActive() .and. rs:promoteRStoAlias("tb") ) // successful and
                                                        // promoted? 
      ? tb->(Alias()), Select(), LastRec()
      Local aStru := DbStruct()
      For iCt := 1 To Len(aStru)
        ? "Field: " + aStru[iCt,1] + " Type: " + aStru[iCt,2] + " Size:" + ;
          Str(aStru[iCt,3],3) + " Dec:" + Str(aStru[iCt,4],3)
      Next
      ? "press...";Inkey(0)

      Go Top
      Browse()
      Close tb
    Endif

    oConn:disconnect()
  Endif
  Return

// ------------------------------------------------------------------------ 011
Function Test011() // Export Operation

  // Goal: Demonstrates an export operation using rqFBConn. It DOES NOT 
  // ====  recreate index files.
  Local oConn := rqFBConn{ "sample.fdb", USER, USER_PWD, "" } AS rqFBConn

  Clear Screen
  Alert( "TEST011: Export Operation" )
  IF oConn:isConnected()

    // IMPORTANT: "/tmp" right below MUST be in firebird.conf as an allowed 
    //            directory to work with external tables. 
    //            Ex: ExternalFileAccess = Restrict /tmp
    oConn:setFullpathDATFile( "/tmp/temp.dat" )

    IF oConn:isTable( "mydbf" )
      oConn:exileTable( "mydbf" ) // recreates mydbf.dbf file deleted in
                                  // Test003
    Endif

    oConn:disconnect()
  Endif
  Return

Function Test012() // Hybrid use (DBFIDX and RQRDDFIRE)
  
  // Goal: Demonstrates the hybird use of DBFIDX and RQRDDFIRE
  Local oConn := rqFBConn{ "sample.fdb", USER, USER_PWD, "" } AS rqFBConn

  Clear Screen
  Alert( "TEST012: Hybrid use" )
  IF oConn:isConnected()
    oConn:setLogLevel( 8 ) // optional: observe /var/log/rqrddfire.log file
    m->oConn1 := oConn  // HIGHLY NEEDED! see Test003

    Use mydbf Alias tb1 Via rqRDDFire Shared New
    Use mydbf Alias tb2 Shared New
    Sele tb1
    Go Bottom
    ? "This is a Firebird area", Alias(), Recno(), Reccount() ; Inkey(0)
    Sele tb2
    ? "This is a Dbf area", Alias(), Recno(), Reccount() ; Inkey(0)
    Close tb2
    Close tb1

    oConn:disconnect()
  Endif
  Return

/*

Q U I C K  R E F E R E N C E 
=============== rqFBConn ===

--
--  FB = Firebird 
--  FS = FlagShip
--  CONNOBJ = Connection object
--

retA = CONNOBJ:getTablesName()
               <retA> Array with all database tables name

retC = CONNOBJ:getDatabaseName()
               <retC> Full name of actual database

retC = CONNOBJ:getFullPathDATFile()
               <retC> Fullpath name of the temporary DAT file. For BRING and
                      EXILE purposes

retN = CONNOBJ:getLogLevel()
               <retN> 0 (w/o log) to 10 (more detailed)
 
retN = CONNOBJ:getGlbSkipMode()
               <retN> 0 (strict), 1 (default), 2 (faster)

retN = CONNOBJ:getGlbSkipCacheSize()
               <retN> Cache size in records

retL = CONNOBJ:dropTable(expC1)
               <expC1> FB table name

ret  = CONNOBJ:EvalMeth(expC1,expA1)
               <expC1> Any method of the actual conn object
               <expA1> Array with parameters of the method
               <ret>   Depends of the chosen method

retL = CONNOBJ:isConnected()

retL = CONNOBJ:isRDDActive()

retL = CONNOBJ:isTable(expC1)
               <expC1> FB table name

retL = CONNOBJ:isIndex(expC1) 
               <expC1> FB index name

retL = CONNOBJ:isIndexOfTable(expC1,expC2)
               <expC1> FB table name
               <expC2> FB index name

retL = CONNOBJ:isRQRDDTable(expC1)
               <expC1) FB table name

retL = CONNOBJ:isFirebirdArea(expC1)
               <expC1) FS alias

retL = CONNOBJ:bringDBF(expC1)
               <expC1> Fullpath and DBF name with extension

retL = CONNOBJ:exileTable(expC1)
               <expC1> FB table name

       CONNOBJ:setLogLevel(expN1)
               <expN1> From 0 (w/o log) to 10 (more detailed)
       
       CONNOBJ:setGlbSkipMode(expN1)
               <expN1> 0 (strict), 1 (default), 2 (faster)
       
       CONNOBJ:setGlbSkipCacheSize(expN1)
               <expN1> Cache size in records
       
retC = CONNOBJ:setFullPathDATFile(expC1)
               <expC1> Fullpath name of the temporary DAT file. For BRING and
                       EXILE purposes
                       Default is /tmp/temp.dat
               <retC> = <expC1>

       CONNOBJ:disconnect()
*/
